% RA: 01-fichas.in
% Puzle de fichas en línea
% Departamento de Ciencias de la Computación e Inteligencia Artificial
% Universidad de Sevilla
%==============================================================================


%==============================================================================
% Enunciado
%==============================================================================

%   Un puzle está compuesto por las siguientes cuatro fichas:

%   Utilizar Otter para encontrar todas las maneras posibles de colocar estas
% cuatro fichas en línea, sin repetir, de forma que los colores de los lados
% adyacentes coincidan. Las fichas no se pueden girar.

%==============================================================================
% Formalización
%==============================================================================

% Lenguaje:
% ficha(x,y,z) - La ficha x tiene a la izquierda el color y, y a la derecha el
%                color z.
% posicion(x1,x2,x3,x4)
%   Las fichas x1, x2, x3, x4 son distintas y se pueden colocar en línea de 
%   forma que los colores de los lados adyacentes coinciden.

set(hyper_res).
set(para_into).
set(para_from).
assign(max_proofs,-1).

formula_list(sos).
 all x1 x2 x3 x4 y1 y2 y3 y4 y5
  ((ficha(x1,y1,y2) & ficha(x2,y2,y3) &
    ficha(x3,y3,y4) & ficha(x4,y4,y5) &
    x1 != x2 & x1 != x3 & x1 != x4 & 
    x2 != x3 & x2 != x4 & x3 != x4) -> posicion(x1,x2,x3,x4)).

 ficha(1,rojo,verde).
 ficha(2,verde,rojo).
 ficha(3,azul,verde).
 ficha(4,rojo,azul).

 1 != 2.
 1 != 3.
 1 != 4.
 2 != 3.
 2 != 4.
 3 != 4.

 1 = 1.
 2 = 2.
 3 = 3.
 4 = 4.
end_of_list.

formula_list(passive).
 all x1 x2 x3 x4 (posicion(x1,x2,x3,x4) -> $ANS(x1,x2,x3,x4)).
end_of_list.

%==============================================================================
